<?php

namespace Teknisa\MAN\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;

class SelectBrinde extends CrudWithParameterBag {

    protected $dataSourceName = 'vnd10110_CampFid_Brind';
    protected $parameterBagColumns = array('NRORG', 'CDCAMPANHA');

	protected $entityManager; 
	protected $dataSourceManager;
	protected $parameterBag;

	public function __construct(Manager $dataSourceManager, ParameterBag $parameterBag, EntityManager $entityManager)  {
	    $this->dataSourceManager = $dataSourceManager;
	    $this->parameterBag = $parameterBag;
		$this->entityManager = $entityManager;
	}
    
    public function saveProdutoParticipante(DTO\Request\DataSet $request, DTO\Response $response) {
        $conditions = $request->getDataSet();
        $rows = $conditions->getRows()[0];
        if($rows['__is_new'] == true) {  
            $aux = '_';
            
            $produtos = array ();
            if($rows['CDARVPRODINI'] === $rows['CDARVPRODFIN']) {
                $produtos[0] = $rows['CDPRODUTOINI'];
            } else {  	
               	$params = array("CDARVPRODINI" => $rows['CDARVPRODINI'], "CDARVPRODFIN" => $rows['CDARVPRODFIN'], "CDNVPRODUTO" => $rows['CDNVPRODUTO'], "PRODUTOS" => $aux);
                $produtos = array_column($this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PRODUCTS_BETWEEN_TWO, $params), 'CDPRODUTO');    
            }
            $params = array("CDCAMPANHA" => $rows['CDCAMPANHA']);
            $rowsToSave = [];
            for($i=0; $i<count($produtos); $i++) {
               array_push($rowsToSave, clone $rows);
                $rowsToSave[$i]['CDPRODUTO'] = $produtos[$i];
            }
            $newRequest = new DTO\Request\DataSet (
                new DataSet($this->dataSourceName, $rowsToSave) , 
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
            
            $this->saveWithoutNotification($newRequest, $response);
        } else {
            $this->saveWithoutNotification($request, $response);
        }
    }
	
	private function saveWithoutNotification($request, $response) {
		try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $nrPersistedRows = count($persistedRows);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
	}
}