<?php
    /*Feito por Victor Rangel
    Produto Odhen*/
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;

class MovimentoCaixa {

	protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	private function verificaRetorno($result) {
		if(empty($result)) {
			return $result; // array(0) 
		} else {
			if(count($result) > 1) {
				return $result; // array(array(), ...)
			} else {
				return $result[0]; // obj / array('CDCAIXA'...) 
			}
		}
	}
	
	public function adqPesqFilial($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqPesqFilial, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqPesqRE($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqPesqRE, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqPesqDtMes($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqPesqDtMes, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqExportacaoTG($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqExportacaoTG, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function acmDelEXPORTACAOTG($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::acmDelEXPORTACAOTG, $params);
		return $query;
	}
	
	public function adqMovVenda($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqMovVenda, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqVerificaRe($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqVerificaRe, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function acmInsereNovoCodigo($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::acmInsereNovoCodigo, $params);
		return $query;
	}
	
	public function adqSomatoria($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqSomatoria, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqMovCaixaAux($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqMovCaixaAux, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqCaixaControle($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqCaixaControle, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqCaixas($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqCaixas, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqDN($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqDN, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqTotalVenda($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqTotalVenda, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqTotalSangria($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqTotalSangria, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqECF($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqECF, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqReducaoZ($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqReducaoZ, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqTotalVendaVA($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqTotalVendaVA, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqPARAVEND($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqPARAVEND, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function acmInsEXPORTACAOTG($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::acmInsEXPORTACAOTG, $params);
		return $query;
	}
	
	public function adqMovCaixa($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqMovCaixa, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function adqContraValeDC($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqContraValeDC, $params);
		$query = $this->verificaRetorno($query);
		return $query;
	}
	
	public function acmUpdTurcaixa($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::acmUpdTurcaixa, $params);
		return $query;
	}
	
	public function adqVdTurCaixa($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqVdTurCaixa, $params);
		return $query;
	}
	
	public function adqNotas($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqNotas, $params);
		return $query;
	}
							
	const adqPesqFilial = "SELECT NRINSJURFILI
								FROM FILIAL
						   WHERE
							  CDFILIAL = :CDFILIAL AND
							  NRORG = :NRORG";
	
	const adqPesqRE = "SELECT MAX(NRNUMERORETG) AS NRNUMERORETG, CDFILIALTG
								FROM EXPORTACAOTG
					   WHERE TO_CHAR(DTCONTABILTG, 'MM')   = :MES AND
						       TO_CHAR(DTCONTABILTG, 'YYYY') = :ANO AND
						       ((INSTR(:LOJAS, CDFILIALTG) <> 0)) AND
						       (IDTPEXPORTACAO = 'TC')
					   GROUP BY CDFILIALTG";
					   
	const adqPesqDtMes = "SELECT DTCONTABILTG, CDFILIALTG
							FROM EXPORTACAOTG
						WHERE
						   TO_CHAR(DTCONTABILTG, 'MM')   = :MES AND
						   TO_CHAR(DTCONTABILTG, 'YYYY') = :ANO";
						
	const adqExportacaoTG = "SELECT NRNUMERORETG, CDEMPRESATG
								FROM EXPORTACAOTG
							 WHERE CDFILIALTG in (SELECT SUBSTR(LPAD(CDLOJA, 10, '0'), 7, 4)
							                    	FROM LOJA
							                      WHERE CDFILIAL = :CDFILIAL AND
							                    		NRORG = :NRORG AND
							                    	((INSTR(:CDFILIALTG, CDLOJA) <> 0))) AND
								DTCONTABILTG = :DTCONTABILTG AND
								IDTPEXPORTACAO = 'TC' ";
								
	const acmDelEXPORTACAOTG = "DELETE FROM EXPORTACAOTG
								WHERE CDFILIALTG in (SELECT SUBSTR(LPAD(CDLOJA, 10, '0'), 7, 4)
									                     FROM LOJA
									                    	WHERE CDFILIAL = :CDFILIAL AND 
									                    		  NRORG = :NRORG AND
									                    		((INSTR(:CDFILIALTG, CDLOJA) <> 0))) AND
									DTCONTABILTG = :DTCONTABILTG AND
									IDTPEXPORTACAO = 'TC' ";
									
	const adqMovVenda = "SELECT
						  'Controle' AS TPMOVIVEND, TC.CDDOCTPRECETC AS DOC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						  TC.IDTIPORECE, TC.CDADMINCART, NVL(TC.IDIMPTPRECETC, 'N') AS IDIMPTPRECETC,
						  SUM(VRMOVIVEND) AS VRVALOR, SUM(VRMOVIVEND) AS VRABSOLUTO, MO.DTMOVIMCAIXA,
						  TC.CDPRODTPRECETC AS CDPRODINTE, 0 AS VRDESCONTO
						FROM
						  MOVCAIXA MO, TIPORECE TC, CAIXA CA
						WHERE
						  (MO.CDFILIAL = :CDFILIAL) AND
						  ((INSTR(:CDLOJA, CA.CDLOJA) <> 0)) AND
						  (MO.DTMOVIMCAIXA = :DATA) AND
						  (MO.CDFILIAL = CA.CDFILIAL) AND
						  (MO.CDCAIXA = CA.CDCAIXA) AND
						  (MO.IDTIPOMOVIVE = NVL(TC.IDVALORCXATC, 'E')) AND
						  (CA.IDCONFVENDA = '2') AND
						  (TC.IDTIPORECE <> '7') AND
						  (TC.IDIMPTPRECETC = 'S') AND
						  (TC.CDTIPORECE = MO.CDTIPORECE) AND
						  (CA.IDCONSCAIXATC = 'S') AND 
						  (MO.NRORG = TC.NRORG) AND
						  (MO.NRORG = CA.NRORG) AND
						  (MO.NRORG = :NRORG)
						GROUP BY
						  TC.CDDOCTPRECETC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						   TC.IDTIPORECE, TC.CDADMINCART, NVL(TC.IDIMPTPRECETC, 'N'),
						  MO.DTMOVIMCAIXA, TC.CDPRODTPRECETC
						HAVING SUM(VRMOVIVEND) > 0
						UNION ALL
						SELECT
						  'Controle' AS TPMOVIVEND, PG.CDDOCCREDPESTC AS DOC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						   TC.IDTIPORECE, '99999999999999' AS CDADMINCART, NVL(PG.IDIMPCREDPESTC, 'N') AS IDIMPTPRECETC,
						  SUM(VRMOVIVEND) AS VRVALOR, SUM(VRMOVIVEND) AS VRABSOLUTO, MO.DTMOVIMCAIXA,
						  PG.CDPRODCREDPESTC AS CDPRODINTE, 0 AS VRDESCONTO
						FROM
						  MOVCAIXA MO, TIPORECE TC, CAIXA CA, PARAMGERAL PG
						WHERE
						  (MO.CDFILIAL = :CDFILIAL) AND
						  ((INSTR(:CDLOJA, CA.CDLOJA) <> 0)) AND
						  (MO.DTMOVIMCAIXA = :DATA) AND
						  (MO.CDFILIAL = CA.CDFILIAL) AND
						  (MO.CDCAIXA = CA.CDCAIXA) AND
						  (MO.IDTIPOMOVIVE = 'S') AND
						  (CA.IDCONFVENDA = '2') AND
						  (TC.IDTIPORECE = '9') AND
						  (PG.IDIMPCREDPESTC = 'S') AND
						  (TC.CDTIPORECE = MO.CDTIPORECE) AND
						  (CA.IDCONSCAIXATC = 'S') AND
						  (MO.NRORG = TC.NRORG) AND
						  (MO.NRORG = CA.NRORG) AND
						  (MO.NRORG = PG.NRORG) AND
						  (MO.NRORG = :NRORG)
						GROUP BY
						  PG.CDDOCCREDPESTC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						  TC.IDTIPORECE, NVL(PG.IDIMPCREDPESTC, 'N'),
						  MO.DTMOVIMCAIXA, PG.CDPRODCREDPESTC
						HAVING SUM(VRMOVIVEND) > 0
						UNION ALL
						SELECT /*CONTRA-VALE RECEBIDO (+) */
						  'Controle' AS TPMOVIVEND, 'DC' AS DOC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						  TC.IDTIPORECE, TC.CDADMINCART, 'S' AS IDIMPTPRECETC,
						  SUM(VRMOVIVEND) AS VRVALOR, SUM(VRMOVIVEND) AS VRABSOLUTO, MO.DTMOVIMCAIXA,
						  '5599900307' AS CDPRODINTE, 0 AS VRDESCONTO
						FROM
						  MOVCAIXA MO, TIPORECE TC, CAIXA CA
						WHERE
						  (MO.CDFILIAL = :CDFILIAL) AND
						  ((INSTR(:CDLOJA, CA.CDLOJA) <> 0)) AND
						  (MO.DTMOVIMCAIXA = :DATA) AND
						  (MO.CDFILIAL = CA.CDFILIAL) AND
						  (MO.CDCAIXA = CA.CDCAIXA) AND
						  (MO.IDTIPOMOVIVE = 'E') AND
						  (CA.IDCONFVENDA = '2') AND
						  (TC.IDTIPORECE = '7') AND
						  (TC.CDTIPORECE = MO.CDTIPORECE) AND
						  (CA.IDCONSCAIXATC = 'S')AND
						  (MO.NRORG = TC.NRORG) AND
						  (MO.NRORG = CA.NRORG) AND
						  (MO.NRORG = :NRORG)
						GROUP BY
						  MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						  TC.IDTIPORECE, TC.CDADMINCART, MO.DTMOVIMCAIXA
						HAVING SUM(VRMOVIVEND) > 0
						UNION ALL
						SELECT
						  'Controle' AS TPMOVIVEND, TC.CDDOCTPRECETC AS DOC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						   TC.IDTIPORECE, TC.CDADMINCART, NVL(TC.IDIMPTPRECETC, 'N') AS IDIMPTPRECETC,
						  SUM(VRMOVIVEND) AS VRVALOR, SUM(VRMOVIVEND) AS VRABSOLUTO, MO.DTMOVIMCAIXA,
						  TC.CDPRODTPRECETC AS CDPRODINTE, 0 AS VRDESCONTO
						FROM
						   MOVCAIXA MO, TIPORECE TC, CAIXA CA
						WHERE
						  (MO.CDFILIAL = :CDFILIAL) AND
						  ((INSTR(:CDLOJA, CA.CDLOJA) <> 0)) AND
						  (MO.DTMOVIMCAIXA = :DATA) AND
						  (MO.CDFILIAL = CA.CDFILIAL) AND
						  (MO.CDCAIXA = CA.CDCAIXA) AND
						  (MO.IDTIPOMOVIVE = NVL(TC.IDVALORCXATC, 'E')) AND
						  (CA.IDCONFVENDA = '2') AND
						  (TC.IDTIPORECE = '7') AND
						  (TC.IDIMPTPRECETC = 'S') AND
						  (MO.CDTIPORECE = TC.CDTIPORECE) AND
						  (CA.IDCONSCAIXATC = 'S') AND
						  (MO.NRORG = TC.NRORG) AND
						  (MO.NRORG = CA.NRORG) AND
						  (MO.NRORG = :NRORG)
						GROUP BY
						  TC.CDDOCTPRECETC, MO.CDFILIAL, CA.CDLOJA, MO.CDCAIXA,
						  TC.IDTIPORECE, TC.CDADMINCART, NVL(TC.IDIMPTPRECETC, 'N'),
						  MO.DTMOVIMCAIXA, TC.CDPRODTPRECETC
						HAVING SUM(VRMOVIVEND) > 0
						UNION ALL
						SELECT
						  'Venda' AS TPMOVIVEND, 'VA' AS DOC, VE.CDFILIAL, VE.CDLOJA, VE.CDCAIXA,
						   '' AS IDTIPORECE, '' AS CDADMINCART, 'S' AS IDIMPTPRECETC,
						  SUM(TRUNC((IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)) * QTPRODVEND,2)) AS VRVALOR, 1 AS VRABSOLUTO, VE.DTENTRVENDA,
						  NVL(PR.CDPRODINTE, PR.CDARVPROD) AS CDPRODINTE, SUM(IT.VRDESITVEND) AS VRDESCONTO
						FROM
						  VENDA VE, ITEMVENDA IT, PRODUTO PR, CAIXA CA
						WHERE
						  (VE.CDFILIAL = :CDFILIAL) AND
						  ((INSTR(:CDLOJA, VE.CDLOJA) <> 0)) AND
						  (VE.DTENTRVENDA = :DATA) AND
						  (IT.CDFILIAL = VE.CDFILIAL) AND
						  (IT.CDCAIXA = VE.CDCAIXA) AND
						  (IT.NRSEQVENDA = VE.NRSEQVENDA) AND
						  (IT.CDPRODUTO = PR.CDPRODUTO) AND
						  (VE.IDSITUVENDA = 'O'       ) AND
						  (IT.CDFILIAL = CA.CDFILIAL  ) AND
						  (IT.CDCAIXA  = CA.CDCAIXA   ) AND
						  (CA.IDCONSCAIXATC = 'S') AND
						  (IT.NRORG = VE.NRORG) AND
						  (IT.NRORG = CA.NRORG) AND
						  (IT.NRORG = PR.NRORG) AND
						  (IT.NRORG = :NRORG)
						GROUP BY
						  VE.CDFILIAL, VE.CDLOJA, VE.CDCAIXA, VE.DTENTRVENDA, NVL(PR.CDPRODINTE, PR.CDARVPROD)
						UNION ALL
						SELECT
						  'ReducaoZ' AS TPMOVIVEND, PG.CDDOCREDZTC AS DOC, VR.CDFILIAL, VR.CDLOJA, VR.CDCAIXA,
						  '' AS IDTIPORECE, '' AS CDADMINCART, NVL(PG.IDIMPREDZTC, 'N') AS IDIMPREDZTC,
						  0 AS VRVALOR, 0 AS VRABSOLUTO, VR.DTREDUCAOZ,
						  NVL(MAX(IT.CDPRODUTO), PG.CDPRODREDZTC) AS CDPRODINTE, 0 AS VRDESCONTO
						FROM VENDA VE 
						LEFT JOIN ITEMVENDA IT ON
						  (IT.CDFILIAL = VE.CDFILIAL) AND
						  (IT.CDCAIXA = VE.CDCAIXA) AND
						  (IT.NRSEQVENDA = VE.NRSEQVENDA) 
						RIGHT JOIN (SELECT
						     RZ.CDFILIAL, CA.CDLOJA, RZ.CDCAIXA, RZ.DTREDUCAOZ
						   FROM
						     REDUCAOZ RZ, CAIXA CA
						   WHERE
						     (RZ.CDFILIAL = :CDFILIAL) AND
						     (RZ.DTREDUCAOZ = :DATA) AND
						     (RZ.CDFILIAL = CA.CDFILIAL) AND
						     (RZ.CDCAIXA = CA.CDCAIXA) AND
						     ((INSTR(:CDLOJA, CA.CDLOJA) <> 0)) AND
						     (CA.IDCONFVENDA = '1') AND
						     (CA.IDCONSCAIXATC = 'S') AND
						     (RZ.NRORG = CA.NRORG) AND
							 (RZ.NRORG = :NRORG) AND
						      NOT EXISTS (SELECT 1
						                  FROM
						                    VENDA VE
						                  WHERE
						                    (VE.CDFILIAL = RZ.CDFILIAL) AND
						                    (VE.CDCAIXA  = RZ.CDCAIXA) AND
						                    (VE.DTENTRVENDA = RZ.DTREDUCAOZ) AND
						                    (VE.NRORG = RZ.NRORG) AND
											(VE.NRORG = :NRORG) AND
						                    (VE.IDSITUVENDA = 'O'))) VR ON
						  (VE.CDFILIAL = VR.CDFILIAL) AND
						  (VE.CDCAIXA = VR.CDCAIXA) AND
						  (VE.DTENTRVENDA = VR.DTREDUCAOZ)
						JOIN PARAMGERAL PG ON
						 PG.IDIMPREDZTC = 'S'  
						WHERE  
						  (VE.NRORG = IT.NRORG) AND
						  (VE.NRORG = :NRORG)
						GROUP BY PG.CDDOCREDZTC, VR.CDFILIAL, VR.CDLOJA, VR.CDCAIXA, NVL(PG.IDIMPREDZTC, 'N'), VR.DTREDUCAOZ, PG.CDPRODREDZTC";

	const adqVerificaRe = "SELECT NRSEQUENCIAL
							  FROM NOVOCODIGO
						   WHERE CDCONTADOR = :CDCONTADOR AND
							  NRORG = :NRORG";
							
	const acmInsereNovoCodigo = "INSERT INTO NOVOCODIGO
									(NRSEQUENCIAL, CDCONTADOR)
								VALUES
									(:NRSEQUENCIAL, :CDCONTADOR)";
								
	const adqSomatoria = "SELECT
							  RE.CDFILIAL, CA.CDLOJA, SUM(RE.NRPRIMCFREDZ) AS VRSOMA
						  FROM
							  REDUCAOZ RE, CAIXA CA
						  WHERE
							  (CA.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (CA.CDFILIAL = RE.CDFILIAL) AND
							  (CA.CDCAIXA = RE.CDCAIXA) AND
							  (RE.DTREDUCAOZ = :DATA) AND
							  (RE.NRORG = :NRORG) AND
							  (CA.NRORG = :NRORG)
						  GROUP BY RE.CDFILIAL,CA.CDLOJA";
						  
	const adqMovCaixaAux = "SELECT
							  'DC' AS TIPO, MO.CDFILIAL, MO.CDCAIXA
							FROM TIPORECE TC  LEFT JOIN INDICE ID
                                                     ON (ID.CDTPINDICE = TC.CDTPINDICE) AND
                                                        (ID.IDPERVALOR = TC.IDPERVALOR) AND
                                                        (ID.CDINDICE = TC.CDINDICE),
                                 MOVCAIXA MO LEFT JOIN CLIENTE CL
                                                    ON (MO.CDCLIENTE = CL.CDCLIENTE),
                            
                                 CAIXA CA
							WHERE
							  (MO.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (MO.DTMOVIMCAIXA = :DATA) AND
							  (MO.CDFILIAL = CA.CDFILIAL) AND
							  (MO.CDCAIXA = CA.CDCAIXA ) AND
							  (MO.IDTIPOMOVIVE = 'G') AND
							  (TC.IDTIPORECE <> '7') AND
							  (CA.IDCONFVENDA = '2' ) AND
							  (TC.CDTIPORECE = MO.CDTIPORECE) AND
			                  (MO.NRORG = :NRORG) AND
			                  (CA.NRORG = :NRORG) AND
			                  (TC.NRORG = :NRORG)
							GROUP BY
							  'DC', MO.CDFILIAL, MO.CDCAIXA
							  
							UNION
							
							SELECT
							  'DC' AS TIPO, MO.CDFILIAL, MO.CDCAIXA
							FROM TIPORECE TC  LEFT JOIN INDICE ID
                                                     ON (ID.CDTPINDICE = TC.CDTPINDICE) AND
                                                        (ID.IDPERVALOR = TC.IDPERVALOR) AND
                                                        (ID.CDINDICE = TC.CDINDICE),
                                 MOVCAIXA MO LEFT JOIN CLIENTE CL
                                                    ON (MO.CDCLIENTE = CL.CDCLIENTE),
                            
                                 CAIXA CA
							WHERE
							  (MO.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (MO.DTMOVIMCAIXA = :DATA) AND
							  (MO.CDFILIAL = CA.CDFILIAL) AND
							  (MO.CDCAIXA = CA.CDCAIXA ) AND
							  (MO.IDTIPOMOVIVE = 'G') AND
							  (TC.IDTIPORECE = '7') AND
							  (CA.IDCONFVENDA = '2' ) AND
							  (TC.CDTIPORECE = MO.CDTIPORECE) AND
			                  (MO.NRORG = :NRORG) AND
			                  (CA.NRORG = :NRORG) AND
			                  (TC.NRORG = :NRORG)
							GROUP BY
							  'DC', MO.CDFILIAL, MO.CDCAIXA
							
							UNION
							
							SELECT
							  'DC' AS TIPO, MO.CDFILIAL, MO.CDCAIXA
							FROM TIPORECE TC  LEFT JOIN INDICE ID
                                                     ON (ID.CDTPINDICE = TC.CDTPINDICE) AND
                                                        (ID.IDPERVALOR = TC.IDPERVALOR) AND
                                                        (ID.CDINDICE = TC.CDINDICE),
                                 MOVCAIXA MO LEFT JOIN CLIENTE CL
                                                    ON (MO.CDCLIENTE = CL.CDCLIENTE),
                            
                                 CAIXA CA
							WHERE
							  (MO.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (MO.DTMOVIMCAIXA = :DATA) AND
							  (MO.CDFILIAL = CA.CDFILIAL) AND
							  (MO.CDCAIXA = CA.CDCAIXA ) AND
							  (MO.IDTIPOMOVIVE = 'S') AND
							  (TC.IDTIPORECE = '7') AND
							  (CA.IDCONFVENDA = '2' ) AND
							  (TC.CDTIPORECE = MO.CDTIPORECE) AND
			                  (MO.NRORG = :NRORG) AND
			                  (CA.NRORG = :NRORG) AND
			                  (TC.NRORG = :NRORG)
							GROUP BY
							  'DC', MO.CDFILIAL, MO.CDCAIXA
							
							UNION
							
							SELECT
							  'DC' AS TIPO, MO.CDFILIAL, MO.CDCAIXA
							FROM TIPORECE TC  LEFT JOIN INDICE ID
                                                     ON (ID.CDTPINDICE = TC.CDTPINDICE) AND
                                                        (ID.IDPERVALOR = TC.IDPERVALOR) AND
                                                        (ID.CDINDICE = TC.CDINDICE),
                                 MOVCAIXA MO LEFT JOIN CLIENTE CL
                                                    ON (MO.CDCLIENTE = CL.CDCLIENTE),
                            
                                 CAIXA CA
							WHERE
							  (MO.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (MO.DTMOVIMCAIXA = :DATA) AND
							  (MO.CDFILIAL = CA.CDFILIAL) AND
							  (MO.CDCAIXA = CA.CDCAIXA ) AND
							  (MO.IDTIPOMOVIVE = 'U') AND
							  (TC.IDTIPORECE <> '7') AND
							  (CA.IDCONFVENDA = '2' ) AND
							  (TC.CDTIPORECE = MO.CDTIPORECE) AND
			                  (MO.NRORG = :NRORG) AND
			                  (CA.NRORG = :NRORG) AND
			                  (TC.NRORG = :NRORG)
							GROUP BY
							  'DC', MO.CDFILIAL, MO.CDCAIXA
							
							UNION
							
							SELECT
							  'DC' AS TIPO, MO.CDFILIAL, MO.CDCAIXA
							FROM TIPORECE TC  LEFT JOIN INDICE ID
                                                     ON (ID.CDTPINDICE = TC.CDTPINDICE) AND
                                                        (ID.IDPERVALOR = TC.IDPERVALOR) AND
                                                        (ID.CDINDICE = TC.CDINDICE),
                                 MOVCAIXA MO LEFT JOIN CLIENTE CL
                                                    ON (MO.CDCLIENTE = CL.CDCLIENTE),
                            
                                 CAIXA CA
							WHERE
							  (MO.CDFILIAL = :CDFILIAL) AND
							  (CA.CDLOJA = :CDLOJA) AND
							  (MO.DTMOVIMCAIXA = :DATA) AND
							  (MO.CDFILIAL = CA.CDFILIAL) AND
							  (MO.CDCAIXA = CA.CDCAIXA ) AND
							  (MO.IDTIPOMOVIVE = 'E') AND
							  (TC.IDTIPORECE <> '7') AND
							  (CA.IDCONFVENDA = '2' ) AND
							  (TC.CDTIPORECE = MO.CDTIPORECE) AND
			                  (MO.NRORG = :NRORG) AND
			                  (CA.NRORG = :NRORG) AND
			                  (TC.NRORG = :NRORG)
							GROUP BY
							  'DC', MO.CDFILIAL, MO.CDCAIXA";
							   
	const adqCaixaControle = "SELECT
								CDFILIAL, CDCAIXA
							  FROM
								CAIXA
							  WHERE
							    (CDFILIAL = :CDFILIAL) AND
							    (CDLOJA = :CDLOJA) AND
							    (IDCONFVENDA = '2') AND
							    (NRORG = :NRORG)";
							    
	const adqCaixas = "SELECT
						  CDFILIAL, CDCAIXA, CDLOJA
					   FROM
						  CAIXA
					   WHERE
						  (CDFILIAL = :CDFILIAL) AND
						  (INSTR(:CDCAIXA, CDFILIAL||CDCAIXACONT) <> 0) AND
						  (:CDLOJA <> CDLOJA) AND
						  (NRORG = :NRORG)";
						  
	const adqDN = "SELECT
					  VE.CDFILIAL, VE.CDLOJA, VE.CDCAIXA,
					  SUM(IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0) * IT.QTPRODVEND) AS VRVALOR,
					  SUM(QTPRODVEND) AS VRABSOLUTO, VE.DTENTRVENDA
				   FROM
					  VENDA VE, ITEMVENDA IT, PRODUTO PR, CAIXA CA
				   WHERE
					  (VE.CDFILIAL = :CDFILIAL) AND
					  (INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) AND
					  (VE.DTENTRVENDA = :DATA) AND
					  (IT.CDFILIAL = VE.CDFILIAL) AND
					  (IT.CDCAIXA = VE.CDCAIXA) AND
					  (IT.NRSEQVENDA = VE.NRSEQVENDA) AND
					  (IT.CDPRODUTO = PR.CDPRODUTO) AND
					  (CA.CDFILIAL = VE.CDFILIAL) AND
					  (CA.CDCAIXA = VE.CDCAIXA) AND
					  (VE.IDSITUVENDA = 'O')   AND
					  (IDCONSCAIXATC = 'S') AND 
					  (VE.NRORG = :NRORG) AND
					  (IT.NRORG = :NRORG) AND
					  (PR.NRORG = :NRORG) AND
					  (CA.NRORG = :NRORG)
				   GROUP BY
					  'F', VE.CDFILIAL, VE.CDLOJA, VE.CDCAIXA, VE.DTENTRVENDA";
					  
	const adqTotalVenda = "SELECT
							  A.CDFILIAL, A.CDLOJA, (NVL(A.VRMOVIVEND,0) - NVL(B.VRMOVIVEND,0)) AS VRTOTVEND
						   FROM
						      (SELECT M.CDFILIAL, C.CDLOJA, SUM(M.VRMOVIVEND) AS VRMOVIVEND
							       FROM MOVCAIXA M, CAIXA C
							       WHERE (M.CDFILIAL = :CDFILIAL) AND
							         (M.DTMOVIMCAIXA = :DATA) AND
							         (M.IDTIPOMOVIVE IN ('E', 'T')) AND
							         (C.CDFILIAL = M.CDFILIAL) AND
							         (C.CDCAIXA = M.CDCAIXA) AND
							         (C.IDCONFVENDA = '1') AND
							         (C.CDLOJA = :CDLOJA) AND
							         (IDCONSCAIXATC = 'S') AND
							         (M.NRORG = :NRORG) AND
							         (C.NRORG = :NRORG)
							      GROUP BY M.CDFILIAL, C.CDLOJA) A LEFT JOIN (SELECT M.CDFILIAL, C.CDLOJA, SUM(M.VRMOVIVEND) AS VRMOVIVEND
                                                                 FROM MOVCAIXA M, CAIXA C
                                                                 WHERE (M.CDFILIAL = :CDFILIAL) AND
                                                                    (M.DTMOVIMCAIXA = :DATA) AND
                                                                    (M.IDTIPOMOVIVE = 'S') AND
                                                                    (C.CDFILIAL = M.CDFILIAL) AND
                                                                    (C.CDCAIXA = M.CDCAIXA) AND
                                                                    (C.IDCONFVENDA = '1') AND
                                                                    (C.CDLOJA = :CDLOJA) AND
                                                                    (IDCONSCAIXATC = 'S') AND
                                                                    (M.NRORG = :NRORG) AND
                                                                    (C.NRORG = :NRORG)
                                                                 GROUP BY M.CDFILIAL, C.CDLOJA) B
                                                                                  ON (A.CDFILIAL = B.CDFILIAL) AND
                                                                                     (A.CDLOJA = B.CDLOJA)";
							 
	const adqTotalSangria = "SELECT
							  A.CDFILIAL, A.CDLOJA, (NVL(A.VRMOVIVEND,0) - NVL(B.VRMOVIVEND,0)) AS VRMOVIVEND
							 FROM
							   (SELECT
							      MO.CDFILIAL, CA.CDLOJA, SUM(NVL(VRMOVIVEND,0)) AS VRMOVIVEND
							    FROM
							      MOVCAIXA MO, CAIXA CA
							    WHERE
							      (MO.CDFILIAL = :CDFILIAL) AND
							      (MO.DTMOVIMCAIXA = :DATA) AND
							      (MO.IDTIPOMOVIVE = 'G') AND
							      (CA.CDFILIAL = MO.CDFILIAL) AND
							      (CA.CDCAIXA = MO.CDCAIXA) AND
							      (CA.IDCONFVENDA = '1') AND
							      (CA.CDLOJA = :CDLOJA) AND
							      (IDCONSCAIXATC = 'S') AND
							      (MO.NRORG = :NRORG) AND
							      (CA.NRORG = :NRORG)
							    GROUP BY
							      MO.CDFILIAL, CA.CDLOJA) A LEFT JOIN
			                                                  (SELECT
			                                                      MO.CDFILIAL, CA.CDLOJA, SUM(NVL(VRMOVIVEND,0)) AS VRMOVIVEND
			                                                   FROM
			                                                      MOVCAIXA MO, CAIXA CA, TIPORECE TP
			                                                   WHERE
			                                                      (MO.CDFILIAL = :CDFILIAL) AND
			                                                      (MO.DTMOVIMCAIXA = :DATA) AND
			                                                      (MO.IDTIPOMOVIVE = 'S') AND
			                                                      (CA.CDFILIAL = MO.CDFILIAL) AND
			                                                      (CA.CDCAIXA = MO.CDCAIXA) AND
			                                                      (CA.IDCONFVENDA = '1') AND
			                                                      (CA.CDLOJA = :CDLOJA) AND
			                                                      (TP.CDTIPORECE = MO.CDTIPORECE) AND
			                                                      (TP.IDTIPORECE = '7') AND
			                                                      (IDCONSCAIXATC = 'S') AND
			                                                      (MO.NRORG = :NRORG) AND
			                                                      (CA.NRORG = :NRORG) AND
			                                                      (TP.NRORG = :NRORG)
			                                                   GROUP BY
			                                                      MO.CDFILIAL, CA.CDLOJA ) B
			                                              ON
			                                                (A.CDFILIAL = B.CDFILIAL) AND
															(A.CDLOJA = B.CDLOJA)";
							  
	const adqECF = "SELECT
					  DISTINCT NRECFTURCAIX
					FROM
					  TURCAIXA
					WHERE
					  (CDFILIAL = :CDFILIAL) AND
					  (CDCAIXA = :CDCAIXA) AND
					  (DTMOVTURCAIX = :DATA) AND
					  (NRORG = :NRORG)";
					  
	const adqReducaoZ = "SELECT
							NRPRIMCFREDZ, NRULTCFREDZ, VRGTREDZ, VRTOTCANREDZ,
							(VRGTREDZ - VRVENBRUREDZ) AS VRGTINIREDZ, NRREDREDZ,
							NRREINIREDZ
						 FROM
							REDUCAOZ
						 WHERE
							(CDFILIAL = :CDFILIAL) AND
							(CDCAIXA = :CDCAIXA) AND
							(NRECFREDZ = :NRECFREDZ) AND
							(DTREDUCAOZ = :DTREDUCAOZ) AND
							(NRORG = :NRORG)";
							
	const adqTotalVendaVA = "SELECT
							  VE.CDFILIAL, VE.CDLOJA, SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRTOTVEND
							FROM
							  VENDA VE, ITEMVENDA IT
							WHERE
							  (VE.CDFILIAL = :CDFILIAL) AND
							  (VE.CDLOJA = :CDLOJA) AND
							  (VE.CDCAIXA = :CDCAIXA) AND
							  (VE.DTENTRVENDA = :DATA) AND
							  (IT.CDFILIAL = VE.CDFILIAL) AND
							  (IT.CDCAIXA = VE.CDCAIXA) AND
							  (IT.NRSEQVENDA  = VE.NRSEQVENDA) AND
							  (VE.IDSITUVENDA = 'O') AND
							  (VE.NRORG = :NRORG) AND
							  (IT.NRORG = :NRORG)
							GROUP BY VE.CDFILIAL, VE.CDLOJA";
								  
	const adqPARAVEND = "SELECT
						  NVL (IDGERACAOTC, '1') AS IDGERACAOTC
						FROM PARAVEND
						WHERE 
							CDFILIAL = :CDFILIAL AND
							NRORG = :NRORG";
								  
	const adqMovCaixa = "SELECT
					        CDFILIAL, CDLOJA, SUM(VRMOVIVEND) AS VRMOVIVEND
					      FROM
					      (SELECT
					        MO.CDFILIAL, CA.CDLOJA, SUM(NVL(VRMOVIVEND,0)) AS VRMOVIVEND
					      FROM
					        MOVCAIXA MO, CAIXA CA, TIPORECE TP
					      WHERE
					        (MO.CDFILIAL = :CDFILIAL) AND
					        (INSTR(:CDLOJA, CA.CDLOJA) <> 0) AND
					        (MO.DTMOVIMCAIXA = :DATA) AND
					        (MO.CDFILIAL = CA.CDFILIAL) AND
					        (MO.CDCAIXA = CA.CDCAIXA) AND
					        (MO.IDTIPOMOVIVE = NVL(TP.IDVALORCXATC, 'E')) AND
					        (CA.IDCONFVENDA = '2') AND
					        (TP.CDTIPORECE IN (SELECT
					                             CDTIPORECE
					                           FROM
					                             TIPORECE
					                           WHERE
					                             (CDDOCTPRECETC = :CDDOCTPRECETC) AND
					                               ((:TCDPRODTPRECETC = 'T') OR (CDPRODTPRECETC = :CDPRODTPRECETC)) AND
					                               ((CDADMINCART IS NULL AND :TCDADMINCART = 'T') OR (CDADMINCART = :CDADMINCART)) AND
					                             (IDIMPTPRECETC = 'S'))) AND
					        (TP.CDTIPORECE = MO.CDTIPORECE)
					      GROUP BY
					        MO.CDFILIAL, CA.CDLOJA
					      
					      UNION
					      
					      SELECT
					        MO.CDFILIAL, CA.CDLOJA, SUM(NVL(VRMOVIVEND, 0)) AS VRMOVIVEND
					      FROM
					        MOVCAIXA MO, CAIXA CA, TIPORECE TP, PARAMGERAL PG
					      WHERE
					        (MO.CDFILIAL = :CDFILIAL) AND
					        (INSTR(:CDLOJA, CA.CDLOJA) <> 0) AND
					        (MO.DTMOVIMCAIXA = :DATA) AND
					        (MO.CDFILIAL = CA.CDFILIAL) AND
					        (MO.CDCAIXA = CA.CDCAIXA) AND
					        (MO.IDTIPOMOVIVE = 'S') AND
					        (CA.IDCONFVENDA = '2') AND
					        (TP.IDTIPORECE = '9') AND
					        (TP.CDTIPORECE = MO.CDTIPORECE) AND
					        (PG.CDDOCCREDPESTC = :CDDOCTPRECETC) AND
					        ((:TCDPRODTPRECETC = 'T') OR (PG.CDPRODCREDPESTC = :CDPRODTPRECETC)) AND
					        ((:TCDADMINCART = 'T') OR ('99999999999999' = :CDADMINCART +)) AND
					        (PG.IDIMPCREDPESTC = 'S')
					      GROUP BY
					        MO.CDFILIAL, CA.CDLOJA) A
					      GROUP BY
					        CDFILIAL, CDLOJA";
					        
	const adqContraValeDC = "SELECT
						        MO.CDFILIAL, CA.CDLOJA, SUM(NVL(VRMOVIVEND,0)) AS VRMOVIVEND
						      FROM
						        MOVCAIXA MO, CAIXA CA, TIPORECE TP
						      WHERE
						        (MO.CDFILIAL = :CDFILIAL) AND
						        (INSTR(:CDLOJA, CA.CDLOJA) <> 0) AND
						        (MO.DTMOVIMCAIXA = :DATA) AND
						        (MO.CDFILIAL = CA.CDFILIAL) AND
						        (MO.CDCAIXA = CA.CDCAIXA) AND
						        (MO.IDTIPOMOVIVE = 'E') AND
						        (CA.IDCONFVENDA = '2') AND
						        (TP.IDTIPORECE = '7') AND
						        (TP.CDTIPORECE = MO.CDTIPORECE)
						      GROUP BY
						        MO.CDFILIAL, CA.CDLOJA";
	
	const acmUpdTurcaixa = "UPDATE TURCAIXA
						      SET IDCXLIBERADO = 'S'
						      WHERE CDFILIAL = :CDFILIAL AND
						      DTMOVTURCAIX = :DATA AND
						      NRORG = :NRORG";
						      
	const adqVdTurCaixa = "SELECT 1
							  FROM TURCAIXA
							 WHERE CDFILIAL = :CDFILIAL
							   AND DTMOVTURCAIX = :DATA
							   AND DTFECHCAIX IS NULL";
							   
	const adqNotas = "SELECT 1
						  FROM VENDA
						 WHERE CDFILIAL     = :CDFILIAL
						   AND DTENTRVENDA  = :DATA
						   AND IDSITUVENDA  = 'O'
						   AND IDTPEMISVEND = 'N'
						   AND IDTPAMBNFCE  = '1'
						   AND IDSTATUSNFCE <> 'A'";
	
	const acmInsEXPORTACAOTG = "INSERT INTO EXPORTACAOTG
								  (CDEMPRESATG,
								   CDFILIALTG,
								   NRNUMERORETG,
								   DTCONTABILTG,
								   VRSOMNUMDCTG,
								   CDTIPOOPERTG,
								   IDTPIJURNFTG,
								   NRINSJURNFTG,
								   NRNOTAFISCTG,
								   CDSERIEENTTG,
								   DTEMISSAOTG,
								   DTATVENPAGTG,
								   CDFILIRECETG,
								   VRDESPESATG,
								   VRDESCONTOTG,
								   VRICMSRETITG,
								   VRIRRETIDOTG,
								   NRINIMAQRETG,
								   NRFIMMAQRETG,
								   NRTOTMAQRETG,
								   CDPRODUTOTG,
								   QTITEMPRODTG,
								   VRUNITITEMTG,
								   VRDESCITEMTG,
								   VRIPIPRODTG,
								   VRNOTAFISCTG,
								   CDFILIEMITTG,
								   IDALTERADATG,
								   CDFIORIGDETG,
								   CDSERORIDETG,
								   NRIJURORIGDE,
								   CDCFISCOPTG,
								   NRLANBOLETTG,
								   VRDOTACAOTG,
								   VRIMPINSSTG,
								   VRIMPISSTG,
								   NRMAQREGTG,
								   NRREDUCAOTG,
								   VLRMAQRETG,
								   VLRCANCANTG,
								   CROTG,
								   IDTPEXPORTACAO)
								VALUES
								  (:CDEMPRESATG,
								   :CDFILIALTG,
								   :NRNUMERORETG,
								   :DTCONTABILTG,
								   :VRSOMNUMDCTG,
								   :CDTIPOOPERTG,
								   :IDTPIJURNFTG,
								   :NRINSJURNFTG,
								   :NRNOTAFISCTG,
								   :CDSERIEENTTG,
								   :DTEMISSAOTG,
								   :DTATVENPAGTG,
								   :CDFILIRECETG,
								   :VRDESPESATG,
								   :VRDESCONTOTG,
								   :VRICMSRETITG,
								   :VRIRRETIDOTG,
								   :NRINIMAQRETG,
								   :NRFIMMAQRETG,
								   :NRTOTMAQRETG,
								   :CDPRODUTOTG,
								   :QTITEMPRODTG,
								   :VRUNITITEMTG,
								   :VRDESCITEMTG,
								   :VRIPIPRODTG,
								   :VRNOTAFISCTG,
								   :CDFILIEMITTG,
								   :IDALTERADATG,
								   :CDFIORIGDETG,
								   :CDSERORIDETG,
								   :NRIJURORIGDE,
								   :CDCFISCOPTG,
								   :NRLANBOLETTG,
								   :VRDOTACAOTG,
								   :VRIMPINSSTG,
								   :VRIMPISSTG,
								   :NRMAQREGTG,
								   :NRREDUCAOTG,
								   :VLRMAQRETG,
								   :VLRCANCANTG,
								   :CROTG,
								   'TC')";
}
?>